Index: code/branches/FICN/src/network/GameStateManager.cc
===================================================================
--- code/branches/FICN/src/network/GameStateManager.cc	(revision 774)
+++ code/branches/FICN/src/network/GameStateManager.cc	(revision 777)
@@ -1,28 +1,28 @@
 /*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Oliver Scheuss, (C) 2007
- *   Co-authors:
- *      ...
- *
- */
+*   ORXONOX - the hottest 3D action shooter ever to exist
+*
+*
+*   License notice:
+*
+*   This program is free software; you can redistribute it and/or
+*   modify it under the terms of the GNU General Public License
+*   as published by the Free Software Foundation; either version 2
+*   of the License, or (at your option) any later version.
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*
+*   Author:
+*      Oliver Scheuss, (C) 2007
+*   Co-authors:
+*      ...
+*
+*/
 
 //
@@ -37,206 +37,206 @@
 //
 //
+
+#include <utility>
+#include <iostream>
+#include <zlib.h>
+
+#include "core/CoreIncludes.h"
+#include "ClientInformation.h"
+#include "Synchronisable.h"
 #include "GameStateManager.h"
 
-namespace network {
-
-GameStateManager::GameStateManager(ClientInformation *head)
+namespace network
 {
-  id=0;
-  head_=head;
+  GameStateManager::GameStateManager(ClientInformation *head) {
+    id=0;
+    head_=head;
+  }
+
+  GameStateManager::~GameStateManager() {
+  }
+
+  void GameStateManager::update(){
+    reference = getSnapshot(id);
+    gameStateMap.insert(std::pair<int, GameState*>(id, reference));
+    gameStateUsed[id]=0;
+    ++id;
+    return;
+  }
+
+  GameStateCompressed GameStateManager::popGameState(int clientID) {
+    int gID = head_->findClient(clientID)->getGamestateID();
+    std::cout << "popgamestate: sending gstate id: " << id << "diffed from: " << gID << std::endl;
+    if(gID!=GAMESTATEID_INITIAL){
+      GameState *client = gameStateMap[gID];
+      GameState *server = reference;
+      //head_->findClient(clientID)->setGamestateID(id);
+      return encode(client, server);
+    } else {
+      GameState *server = reference;
+      //head_->findClient(clientID)->setGamestateID(id);
+      return encode(server);
+      // return an undiffed gamestate and set appropriate flags
+    }
+  }
+
+  /**
+  * This function goes through the whole list of synchronisables and
+  * saves all the synchronisables to a flat "list".
+  * @return struct of type gamestate containing the size of the whole gamestate and a pointer linking to the flat list
+  */
+  GameState *GameStateManager::getSnapshot(int id)
+  {
+    //the size of the gamestate
+    int totalsize=0;
+    int memsize=1000;
+    //the size of one specific synchronisable
+    int tempsize=0;
+    // get the start of the Synchronisable list
+    orxonox::Iterator<Synchronisable> it;
+    // struct for return value of Synchronisable::getData()
+    syncData sync;
+
+    GameState *retval=new GameState; //return value
+    retval->id=id++;
+    std::cout << "producing gamestate with id: " << retval->id << std::endl;
+    // reserve a little memory and increase it later on
+    //COUT(2) << "mallocing" << std::endl;
+    retval->data = (unsigned char*)malloc(memsize);
+    //COUT(2) << "malloced" << std::endl;
+
+    // offset of memory functions
+    int offset=0;
+    // go through all Synchronisables
+    for(it = orxonox::ObjectList<Synchronisable>::start(); it != 0; ++it){
+      //std::cout << "gamestatemanager: in for loop" << std::endl;
+      //get size of the synchronisable
+      tempsize=it->getSize();
+      //std::cout << "size of temp gamestate: " << tempsize << std::endl;
+      //COUT(2) << "size of synchronisable: " << tempsize << std::endl;
+      // add place for data and 3 ints (length,classid,objectid)
+      totalsize+=tempsize+3*sizeof(int);
+      //std::cout << "totalsize: " << totalsize << std::endl;
+      // allocate additional space
+      if(totalsize+tempsize>memsize){
+        if(tempsize<1000){
+          retval->data = (unsigned char *)realloc((void *)retval->data, totalsize+1000);
+          memsize+=1000;
+        } else {
+          retval->data = (unsigned char *)realloc((void *)retval->data, totalsize+1000);
+          memsize+=tempsize+1000;
+        }
+      }
+
+      // run Synchronisable::getData with offset and additional place for 3 ints in between (for ids and length)
+      sync=it->getData((retval->data)+offset+3*sizeof(int));
+      *(retval->data+offset)=sync.length;
+      *(retval->data+offset+sizeof(int))=sync.objectID;
+      *(retval->data+offset+2*sizeof(int))=sync.classID;
+      // increase data pointer
+      offset+=tempsize+3*sizeof(int);
+    }
+    retval->size=totalsize;
+    return retval;
+  }
+
+  GameStateCompressed GameStateManager::encode(GameState *a, GameState *b) {
+    //GameState r = diff(a,b);
+    //r.diffed = true;
+    GameState r = *b;
+    r.diffed = false;
+    return compress_(&r);
+  }
+
+  GameStateCompressed GameStateManager::encode(GameState *a) {
+    a->diffed=false;
+    return compress_(a);
+  }
+
+  GameState GameStateManager::diff(GameState *a, GameState *b) {
+    unsigned char *ap = a->data, *bp = b->data;
+    int of=0; // pointers offset
+    int dest_length=0;
+    if(a->size>=b->size)
+      dest_length=a->size;
+    else
+      dest_length=b->size;
+    unsigned char *dp = (unsigned char *)malloc(dest_length*sizeof(unsigned char));
+    while(of<a->size && of<b->size){
+      *(dp+of)=*(ap+of)^*(bp+of); // do the xor
+      ++of;
+    }
+    if(a->size!=b->size){ // do we have to fill up ?
+      unsigned char n=0;
+      if(a->size<b->size){
+        while(of<dest_length){
+          *(dp+of)=n^*(bp+of);
+          of++;
+        }
+      } else{
+        while(of<dest_length){
+          *(dp+of)=*(ap+of)^n;
+          of++;
+        }
+      }
+    }
+    // should be finished now
+    GameState r = {b->id, dest_length, dp};
+    return r;
+  }
+
+  GameStateCompressed GameStateManager::compress_(GameState *a) {
+    //COUT(2) << "compressing gamestate" << std::endl;
+    int size = a->size;
+    uLongf buffer = (uLongf)((a->size + 12)*1.01)+1;
+    unsigned char* dest = (unsigned char*)malloc( buffer );
+    int retval;
+    //std::cout << "before ziped " << buffer << std::endl;
+    retval = compress( dest, &buffer, a->data, (uLong)size );
+    //std::cout << "after ziped " << buffer << std::endl;
+
+    switch ( retval ) {
+      case Z_OK: std::cout << "successfully compressed" << std::endl; break;
+      case Z_MEM_ERROR: std::cout << "not enough memory available" << std::endl; break;
+      case Z_BUF_ERROR: std::cout << "not enough memory available in the buffer" << std::endl; break;
+      case Z_DATA_ERROR: std::cout << "decompress: data corrupted" << std::endl; break;
+    }
+
+    GameStateCompressed compressedGamestate;
+    compressedGamestate.compsize = buffer;
+    //std::cout << "compressedGamestate.compsize = buffer; " << buffer << std::endl;
+    compressedGamestate.normsize = size;
+    //std::cout << "compressedGamestate.normsize = size; " << size << std::endl;
+    compressedGamestate.id = a->id;
+    compressedGamestate.data = dest;
+    compressedGamestate.diffed = a->diffed;
+
+    return compressedGamestate;
+  }
+
+  void GameStateManager::ackGameState(int clientID, int gamestateID) {
+    ClientInformation *temp = head_->findClient(clientID);
+    int curid = temp->getID();
+    // decrease usage of gamestate and save it
+    deleteUnusedGameState(curid);
+    //increase gamestateused
+    ++gameStateUsed.find(gamestateID)->second;
+    temp->setGamestateID(gamestateID);
+    /*
+    GameState *old = clientGameState[clientID];
+    deleteUnusedGameState(old);
+    clientGameState[clientID]=idGameState[gamestateID];*/
+  }
+
+  bool GameStateManager::deleteUnusedGameState(int gamestateID) {
+    int used = --(gameStateUsed.find(gamestateID)->second);
+    if(id-gamestateID>KEEP_GAMESTATES && used==0){
+      // delete gamestate
+      delete gameStateMap.find(gamestateID)->second;
+      gameStateMap.erase(gamestateID);
+      return true;
+    }
+    return false;
+  }
+
 }
-
-GameStateManager::~GameStateManager()
-{
-}
-
-void GameStateManager::update(){
-  reference = getSnapshot(id);
-  gameStateMap.insert(std::pair<int, GameState*>(id, reference));
-  gameStateUsed[id]=0;
-  ++id;
-  return;
-}
-
-GameStateCompressed GameStateManager::popGameState(int clientID){
-  int gID = head_->findClient(clientID)->getGamestateID();
-  std::cout << "popgamestate: sending gstate id: " << id << "diffed from: " << gID << std::endl;
-  if(gID!=GAMESTATEID_INITIAL){
-    GameState *client = gameStateMap[gID];
-    GameState *server = reference;
-    //head_->findClient(clientID)->setGamestateID(id);
-    return encode(client, server);
-  } else {
-    GameState *server = reference;
-    //head_->findClient(clientID)->setGamestateID(id);
-    return encode(server);
-    // return an undiffed gamestate and set appropriate flags
-  }
-}
-
-
-
-/**
- * This function goes through the whole list of synchronisables and
- * saves all the synchronisables to a flat "list".
- * @return struct of type gamestate containing the size of the whole gamestate and a pointer linking to the flat list
- */
-GameState *GameStateManager::getSnapshot(int id)
-{
-  //the size of the gamestate
-  int totalsize=0;
-  int memsize=1000;
-  //the size of one specific synchronisable
-  int tempsize=0;
-  // get the start of the Synchronisable list
-  orxonox::Iterator<Synchronisable> it;
-  // struct for return value of Synchronisable::getData()
-  syncData sync;
-
-  GameState *retval=new GameState; //return value
-  retval->id=id++;
-  std::cout << "producing gamestate with id: " << retval->id << std::endl;
-  // reserve a little memory and increase it later on
-  //COUT(2) << "mallocing" << std::endl;
-  retval->data = (unsigned char*)malloc(memsize);
-  //COUT(2) << "malloced" << std::endl;
-
-  // offset of memory functions
-  int offset=0;
-  // go through all Synchronisables
-  for(it = orxonox::ObjectList<Synchronisable>::start(); it != 0; ++it){
-    //std::cout << "gamestatemanager: in for loop" << std::endl;
-    //get size of the synchronisable
-    tempsize=it->getSize();
-    //std::cout << "size of temp gamestate: " << tempsize << std::endl;
-    //COUT(2) << "size of synchronisable: " << tempsize << std::endl;
-    // add place for data and 3 ints (length,classid,objectid)
-    totalsize+=tempsize+3*sizeof(int);
-    //std::cout << "totalsize: " << totalsize << std::endl;
-    // allocate additional space
-    if(totalsize+tempsize>memsize){
-      if(tempsize<1000){
-        retval->data = (unsigned char *)realloc((void *)retval->data, totalsize+1000);
-        memsize+=1000;
-      } else {
-        retval->data = (unsigned char *)realloc((void *)retval->data, totalsize+1000);
-        memsize+=tempsize+1000;
-      }
-    }
-
-    // run Synchronisable::getData with offset and additional place for 3 ints in between (for ids and length)
-    sync=it->getData((retval->data)+offset+3*sizeof(int));
-    *(retval->data+offset)=sync.length;
-    *(retval->data+offset+sizeof(int))=sync.objectID;
-    *(retval->data+offset+2*sizeof(int))=sync.classID;
-    // increase data pointer
-    offset+=tempsize+3*sizeof(int);
-  }
-  retval->size=totalsize;
-  return retval;
-}
-
-
-
-GameStateCompressed GameStateManager::encode(GameState *a, GameState *b){
-  //GameState r = diff(a,b);
-  //r.diffed = true;
-  GameState r = *b;
-  r.diffed = false;
-  return compress_(&r);
-}
-
-GameStateCompressed GameStateManager::encode(GameState *a){
-  a->diffed=false;
-  return compress_(a);
-}
-
-GameState GameStateManager::diff(GameState *a, GameState *b){
-  unsigned char *ap = a->data, *bp = b->data;
-  int of=0; // pointers offset
-  int dest_length=0;
-  if(a->size>=b->size)
-    dest_length=a->size;
-  else
-    dest_length=b->size;
-  unsigned char *dp = (unsigned char *)malloc(dest_length*sizeof(unsigned char));
-  while(of<a->size && of<b->size){
-    *(dp+of)=*(ap+of)^*(bp+of); // do the xor
-    ++of;
-  }
-  if(a->size!=b->size){ // do we have to fill up ?
-    unsigned char n=0;
-    if(a->size<b->size){
-      while(of<dest_length){
-        *(dp+of)=n^*(bp+of);
-        of++;
-      }
-    } else{
-      while(of<dest_length){
-        *(dp+of)=*(ap+of)^n;
-        of++;
-      }
-    }
-  }
-  // should be finished now
-  GameState r = {b->id, dest_length, dp};
-  return r;
-}
-
-GameStateCompressed GameStateManager::compress_(GameState *a) {
-  //COUT(2) << "compressing gamestate" << std::endl;
-  int size = a->size;
-  uLongf buffer = (uLongf)((a->size + 12)*1.01)+1;
-  unsigned char* dest = (unsigned char*)malloc( buffer );
-  int retval;
-  //std::cout << "before ziped " << buffer << std::endl;
-  retval = compress( dest, &buffer, a->data, (uLong)size );
-  //std::cout << "after ziped " << buffer << std::endl;
-
-  switch ( retval ) {
-  case Z_OK: std::cout << "successfully compressed" << std::endl; break;
-  case Z_MEM_ERROR: std::cout << "not enough memory available" << std::endl; break;
-  case Z_BUF_ERROR: std::cout << "not enough memory available in the buffer" << std::endl; break;
-  case Z_DATA_ERROR: std::cout << "decompress: data corrupted" << std::endl; break;
-  }
-
-  GameStateCompressed compressedGamestate;
-  compressedGamestate.compsize = buffer;
-  //std::cout << "compressedGamestate.compsize = buffer; " << buffer << std::endl;
-  compressedGamestate.normsize = size;
-  //std::cout << "compressedGamestate.normsize = size; " << size << std::endl;
-  compressedGamestate.id = a->id;
-  compressedGamestate.data = dest;
-  compressedGamestate.diffed = a->diffed;
-
-  return compressedGamestate;
-}
-
-void GameStateManager::ackGameState(int clientID, int gamestateID){
-  ClientInformation *temp = head_->findClient(clientID);
-  int curid = temp->getID();
-  // decrease usage of gamestate and save it
-  deleteUnusedGameState(curid);
-  //increase gamestateused
-  ++gameStateUsed.find(gamestateID)->second;
-  temp->setGamestateID(gamestateID);
-  /*
-  GameState *old = clientGameState[clientID];
-  deleteUnusedGameState(old);
-  clientGameState[clientID]=idGameState[gamestateID];*/
-}
-
-bool GameStateManager::deleteUnusedGameState(int gamestateID){
-  int used = --(gameStateUsed.find(gamestateID)->second);
-  if(id-gamestateID>KEEP_GAMESTATES && used==0){
-    // delete gamestate
-    delete gameStateMap.find(gamestateID)->second;
-    gameStateMap.erase(gamestateID);
-    return true;
-  }
-  return false;
-}
-
-}
-
-
Index: code/branches/FICN/src/network/GameStateManager.h
===================================================================
--- code/branches/FICN/src/network/GameStateManager.h	(revision 774)
+++ code/branches/FICN/src/network/GameStateManager.h	(revision 777)
@@ -15,52 +15,48 @@
 #include <map>
 
-#include "zlib.h"
-
-#include "ClientInformation.h"
-#include "Synchronisable.h"
-#include "core/CoreIncludes.h"
-#include "core/Iterator.h"
+#include "NetworkPrereqs.h"
 #include "PacketTypes.h"
 
-namespace network {
+namespace network
+{
 
 #define KEEP_GAMESTATES 20
 
-/**
- * This Class implements a manager for gamestates:
- * - creating snapshots of gamestates
- * - writing gamestates to universe
- * - diffing gamestates ?
- * 
- * EN/DECODATION:
- * a: last Gamestate a client has received
- * b: new Gamestate
- * x: diffed and compressed gamestate
- * x=(a^b)
- * b=(a^x)
- * diff(a,diff(a,x))=x (hope this is correct)
- * @author Oliver Scheuss
-*/
-class GameStateManager{
-public:
-  GameStateManager(ClientInformation *head);
-  ~GameStateManager();
-  void update();
-  GameStateCompressed popGameState(int clientID);
-  void ackGameState(int clientID, int gamestateID);
-  int id;
-private:
-  GameState *getSnapshot(int id);
-  GameStateCompressed encode(GameState *a, GameState *b);
-  GameStateCompressed encode(GameState *a);
-  GameState diff(GameState *a, GameState *b);
-  GameStateCompressed compress_(GameState *a);
-  bool deleteUnusedGameState(int gamestateID);
-  
-  std::map<int, GameState*> gameStateMap; //map gsID to gamestate*
-  std::map<int, int> gameStateUsed; // save the number of clients, that use the specific gamestate
-  GameState *reference;
-  ClientInformation *head_;
-};
+  /**
+  * This Class implements a manager for gamestates:
+  * - creating snapshots of gamestates
+  * - writing gamestates to universe
+  * - diffing gamestates ?
+  * 
+  * EN/DECODATION:
+  * a: last Gamestate a client has received
+  * b: new Gamestate
+  * x: diffed and compressed gamestate
+  * x=(a^b)
+  * b=(a^x)
+  * diff(a,diff(a,x))=x (hope this is correct)
+  * @author Oliver Scheuss
+  */
+  class GameStateManager{
+  public:
+    GameStateManager(ClientInformation *head);
+    ~GameStateManager();
+    void update();
+    GameStateCompressed popGameState(int clientID);
+    void ackGameState(int clientID, int gamestateID);
+    int id;
+  private:
+    GameState *getSnapshot(int id);
+    GameStateCompressed encode(GameState *a, GameState *b);
+    GameStateCompressed encode(GameState *a);
+    GameState diff(GameState *a, GameState *b);
+    GameStateCompressed compress_(GameState *a);
+    bool deleteUnusedGameState(int gamestateID);
+
+    std::map<int, GameState*> gameStateMap; //map gsID to gamestate*
+    std::map<int, int> gameStateUsed; // save the number of clients, that use the specific gamestate
+    GameState *reference;
+    ClientInformation *head_;
+  };
 
 }
Index: code/branches/FICN/src/network/NetworkFrameListener.h
===================================================================
--- code/branches/FICN/src/network/NetworkFrameListener.h	(revision 774)
+++ code/branches/FICN/src/network/NetworkFrameListener.h	(revision 777)
@@ -16,30 +16,29 @@
 #include <OgreFrameListener.h>
 
+#include "NetworkPrereqs.h"
 #include "Server.h"
 #include "Client.h"
-//#include <iostream>
-// #include "orxonox/Orxonox.cc"
+
 network::Server *server_g;
 network::Client *client_g;
 
-namespace network{
+namespace network
+{
+  class ServerFrameListener : public Ogre::FrameListener{
+  private:
+    bool frameStarted(const Ogre::FrameEvent &evt){
+      server_g->tick(evt.timeSinceLastFrame);
+      return FrameListener::frameStarted(evt);
+    }
+  };
 
-
-class ServerFrameListener : public Ogre::FrameListener{
-private:
-  bool frameStarted(const Ogre::FrameEvent &evt){
-    server_g->tick(evt.timeSinceLastFrame);
-    return FrameListener::frameStarted(evt);
-  }
-};
-
-class ClientFrameListener : public Ogre::FrameListener{
-private:
-  bool frameStarted(const Ogre::FrameEvent &evt){
-    //std::cout << "framelistener" << std::endl;
-    client_g->tick(evt.timeSinceLastFrame);
-    return FrameListener::frameStarted(evt);
-  }
-};
+  class ClientFrameListener : public Ogre::FrameListener{
+  private:
+    bool frameStarted(const Ogre::FrameEvent &evt){
+      //std::cout << "framelistener" << std::endl;
+      client_g->tick(evt.timeSinceLastFrame);
+      return FrameListener::frameStarted(evt);
+    }
+  };
 
 
Index: code/branches/FICN/src/network/NetworkPrereqs.h
===================================================================
--- code/branches/FICN/src/network/NetworkPrereqs.h	(revision 777)
+++ code/branches/FICN/src/network/NetworkPrereqs.h	(revision 777)
@@ -0,0 +1,90 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file  NetworkPrereqs.h
+ @brief Contains all the necessary forward declarations for all classes, structs and enums.
+ */
+
+#ifndef _NetworkPrereqs_H__
+#define _NetworkPrereqs_H__
+
+#include "orxonox/OrxonoxPlatform.h"
+
+//-----------------------------------------------------------------------
+// Shared library settings
+//-----------------------------------------------------------------------
+#if (ORXONOX_PLATFORM == ORXONOX_PLATFORM_WIN32) && !defined( NETWORK_STATIC_BUILD )
+#  ifdef NETWORK_SHARED_BUILD
+#    define _NetworkExport __declspec(dllexport)
+#  else
+#    if defined( __MINGW32__ )
+#      define _NetworkExport
+#    else
+#      define _NetworkExport __declspec(dllimport)
+#    endif
+#  endif
+#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _NetworkExport  __attribute__ ((visibility("default")))
+#else
+#  define _NetworkExport
+#endif
+
+
+//-----------------------------------------------------------------------
+// Forward declarations
+//-----------------------------------------------------------------------
+namespace network
+{
+  class Client;
+  class ClientConnection;
+  class ClientFrameListener;
+  class ClientInformation;
+  class ConnectionManager;
+  class GameStateClient;
+  class GameStateManager;
+  class PacketBuffer;
+  class PacketDecoder;
+  class PacketGenerator;
+  class Server;
+  class ServerFrameListener;
+  class Synchronisable;
+  struct ack;
+  struct chat;
+  struct classid;
+  struct ClientList;
+  struct GameState;
+  struct GameStateCompressed;
+  struct keyboard;
+  struct mouse;
+  struct PacketEnvelope;
+  struct QueueItem;
+  struct synchData;
+  struct synchronisableVariable;
+}
+
+#endif /* _NetworkPrereqs_H__ */
Index: code/branches/FICN/src/network/PacketBuffer.cc
===================================================================
--- code/branches/FICN/src/network/PacketBuffer.cc	(revision 774)
+++ code/branches/FICN/src/network/PacketBuffer.cc	(revision 777)
@@ -1,28 +1,28 @@
 /*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Oliver Scheuss, (C) 2007
- *   Co-authors:
- *      ...
- *
- */
+*   ORXONOX - the hottest 3D action shooter ever to exist
+*
+*
+*   License notice:
+*
+*   This program is free software; you can redistribute it and/or
+*   modify it under the terms of the GNU General Public License
+*   as published by the Free Software Foundation; either version 2
+*   of the License, or (at your option) any later version.
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*
+*   Author:
+*      Oliver Scheuss, (C) 2007
+*   Co-authors:
+*      ...
+*
+*/
 
 // C++ PacketBuffer
@@ -30,107 +30,107 @@
 // Author Oliver Scheuss
 
-#ifndef NETWORK_PACKETBUFFER_CC
-#define NETWORK_PACKETBUFFER_CC
+#include <iostream>
+#include <queue>
+#include <string>
+#include <boost/bind.hpp>
+#include <boost/thread/mutex.hpp>
 
-#include <iostream>
 #include "PacketBuffer.h"
 
-namespace network{
+namespace network
+{
+  boost::mutex networkPacketBufferMutex;
 
-   boost::mutex networkPacketBufferMutex;
-
-PacketBuffer::PacketBuffer(){
-  closed=false;
-  first=NULL;
-  last=NULL;
-}
-    //this is needed in order to make the packetbuffer threadsafe
+  PacketBuffer::PacketBuffer() {
+    closed=false;
+    first=NULL;
+    last=NULL;
+  }
+  //this is needed in order to make the packetbuffer threadsafe
 
 
-bool PacketBuffer::push(ENetEvent *ev){
-  boost::mutex::scoped_lock lock(networkPacketBufferMutex);
-  //std::cout << "event size inside packetbuffer " << ev->packet->dataLength << std::endl;
-//   if(closed)
-//     return false;
-  // first element?
-  if(first==NULL){
-    first=new QueueItem;
-    last=first;
-    last->next=NULL;
-    // change this!!!!!!!
-    last->packet = ev->packet;
-    last->address = ev->peer->address;
+  bool PacketBuffer::push(ENetEvent *ev) {
+    boost::mutex::scoped_lock lock(networkPacketBufferMutex);
+    //std::cout << "event size inside packetbuffer " << ev->packet->dataLength << std::endl;
+    //   if(closed)
+    //     return false;
+    // first element?
+    if(first==NULL){
+      first=new QueueItem;
+      last=first;
+      last->next=NULL;
+      // change this!!!!!!!
+      last->packet = ev->packet;
+      last->address = ev->peer->address;
     } else {
-    //insert a new element at the bottom
-    last->next = new QueueItem;
-    last=last->next;
-    // initialize last->next
-    last->next=NULL;
-    // save the packet to the new element
-    last->packet = ev->packet;
-    last->address = ev->peer->address;
-  }
-  return true;
-}
-
-ENetPacket *PacketBuffer::pop(){
-  boost::mutex::scoped_lock lock(networkPacketBufferMutex);
-  //std::cout << "packetbuffer pop" << std::endl;
-  if(first!=NULL /*&& !closed*/){
-    QueueItem *temp = first;
-    // get packet
-    ENetPacket *pck=first->packet;
-    // remove first element
-    first = first->next;
-    delete temp;
-    //std::cout << "pop size of packet " << pck->dataLength << std::endl;
-    return pck;
-  } else{
-    //std::cout << "nothing to return" << std::endl;
-    return NULL;
-  }
-}
-
-ENetPacket *PacketBuffer::pop(ENetAddress &address){
-  boost::mutex::scoped_lock lock(networkPacketBufferMutex);
-  //std::cout << "packetbuffer pop(address)" << std::endl;
-  if(first!=NULL /*&& !closed*/){
-    QueueItem *temp = first;
-    // get packet
-    ENetPacket *pck=first->packet;
-    address = first->address;
-    // remove first element
-    first = first->next;
-    delete temp;
-    //std::cout << "pop(address) size of packet " << pck->dataLength << std::endl;
-    return pck;
-  } else{
-    return NULL;
-  }
-}
-
-bool PacketBuffer::isEmpty(){
-  return (first==NULL);
-}
-
-void PacketBuffer::print(){
-  QueueItem *temp=first;
-  while(temp!=NULL){
-//    std::cout << temp->packet->data << std::endl;
-    temp=temp->next;
+      //insert a new element at the bottom
+      last->next = new QueueItem;
+      last=last->next;
+      // initialize last->next
+      last->next=NULL;
+      // save the packet to the new element
+      last->packet = ev->packet;
+      last->address = ev->peer->address;
+    }
+    return true;
   }
 
-}
+  ENetPacket *PacketBuffer::pop() {
+    boost::mutex::scoped_lock lock(networkPacketBufferMutex);
+    //std::cout << "packetbuffer pop" << std::endl;
+    if(first!=NULL /*&& !closed*/){
+      QueueItem *temp = first;
+      // get packet
+      ENetPacket *pck=first->packet;
+      // remove first element
+      first = first->next;
+      delete temp;
+      //std::cout << "pop size of packet " << pck->dataLength << std::endl;
+      return pck;
+    } else{
+      //std::cout << "nothing to return" << std::endl;
+      return NULL;
+    }
+  }
 
-bool PacketBuffer::isClosed(){
-  return closed;
-}
+  ENetPacket *PacketBuffer::pop(ENetAddress &address) {
+    boost::mutex::scoped_lock lock(networkPacketBufferMutex);
+    //std::cout << "packetbuffer pop(address)" << std::endl;
+    if(first!=NULL /*&& !closed*/){
+      QueueItem *temp = first;
+      // get packet
+      ENetPacket *pck=first->packet;
+      address = first->address;
+      // remove first element
+      first = first->next;
+      delete temp;
+      //std::cout << "pop(address) size of packet " << pck->dataLength << std::endl;
+      return pck;
+    } else{
+      return NULL;
+    }
+  }
 
-void PacketBuffer::setClosed(bool value){
-  closed=value;
-  return;
-}
+  bool PacketBuffer::isEmpty() {
+    return (first==NULL);
+  }
 
-}// namespace network
+  void PacketBuffer::print() {
+    QueueItem *temp=first;
+    while(temp!=NULL){
+      //    std::cout << temp->packet->data << std::endl;
+      temp=temp->next;
+    }
 
-#endif
+  }
+
+  bool PacketBuffer::isClosed() {
+    return closed;
+  }
+
+  void PacketBuffer::setClosed(bool value){
+    closed=value;
+    return;
+  }
+
+} // namespace network
